import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load_module, reload_module, get_stdout

exercise = 'src.name_twice'

@points('1.name_twice')
class NameTwiceTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', return_value = ''):
            cls.module = load_module(exercise, 'en')

    def test_print_input_1(self):
        with patch('builtins.input', return_value = 'Paul'):
            reload_module(self.module)
            output = get_stdout()
            self.assertTrue(len(output)>0, "Ditt program skriver inte ut någonting!")
            splitted = output.split('\n')
            self.assertTrue(splitted[0].rstrip() == 'Paul' and splitted[1].rstrip() == 'Paul', f'Ditt program fungerade inte korrekt med input: Paul. Utdata var\n{output}\nFörväntat utdata är\nPekka\nPekka')

    def test_print_input_2(self):
        with patch('builtins.input', return_value = 'Ada'):
            reload_module(self.module)
            output = get_stdout()
            splitted = output.split('\n')
            self.assertTrue(splitted[0].rstrip() == 'Ada' and splitted[1].rstrip() == 'Ada', f'Ditt program fungerade inte korrekt med input: Ada. Utdata var\n{output}\nFörväntat utdata är\nAda\nAda')


    def test_input_is_asked_only_once(self):
        with patch('builtins.input', return_value = '') as prompt:
            reload_module(self.module)
            output = get_stdout()
            try:
                prompt.assert_called_once()
            except AssertionError:
                self.fail('Inmatning bör frågas exakt en gång.')

if __name__ == '__main__':
    unittest.main()
